/* titel: turm.c, turm von hanoi */

#include <stdio.h>
#include <ctype.h>

typedef enum { links, mitte, rechts } turm;

main() { 
  int scheibenzahl;
  void bewege();
  while (1) {
    printf("\nScheibenzahl (Abbruch mit 0): ");
    while ( scanf("%d", &scheibenzahl) == 0 ) {
      getchar(); printf("\nFalsche Eingabe, bitte Zahl >= 0 eingeben: ");
    }
    if (scheibenzahl <= 0)
      break;
    printf ("%d %s\n",scheibenzahl,"Scheiben erfordern folgende Bewegungen:");
    bewege (scheibenzahl, links, mitte, rechts);
  }
}
void bewege (int anzahl, turm von, turm mittels, turm nach) { 
  void bewege_scheibe();
  if ( anzahl == 1 )
    bewege_scheibe (von, nach);
  else { 
    bewege ( anzahl - 1, von, nach, mittels);
    bewege_scheibe ( von, nach );
    bewege ( anzahl - 1, mittels, von, nach);
  }
}
void bewege_scheibe ( turm von, turm nach ) { 
  void print_turm();
  printf ("Scheibe von "); print_turm (von);
  printf (" nach ");       print_turm (nach);
  printf ("\n");
}
void print_turm ( turm welcher ) { 
  switch (welcher) { 
    case links  : printf ("LINKS "); break;
    case mitte  : printf ("MITTE "); break;
    case rechts : printf ("RECHTS"); break;
  }
}
