// templ.cc
#include <iostream.h>
#include "string-class.h"

template <class T>
T max(T x, T y) {
  return ( x > y ) ? x : y;
}
void main() {
  int    x = 1, y = 2;
  float  u = 1.0, v = 0.4;
  double e = 2.7182818, pi = 3.14159265;
  string s = "qwerty";
  string t = "uiop";
  cout << "max("<<x<<","<<y<<") = "<<max(x,y)<<'\n';
  cout << "max("<<u<<","<<v<<") = "<<max(u,v)<<'\n';
  cout << "max("<<e<<","<<pi<<") = "<<max(e,pi)<<'\n';
  cout << "max("<<s<<","<<t<<") = "<<max(s,t)<<'\n';
} /* Typische Ausgabe:    max(1,2) = 2
                          max(1,0.4) = 1
                          max(2.71828,3.14159) = 3.14159 
                          max(qwerty,uiop) = uiop          */
