// fileio1.cc   Lesen und Schreiben von Dateien

#include <iostream.h>
#include <fstream.h>


int main(int argc, char* argv[] ) {
  char c;

  if (argc==1) {          // Nur ein Argument, der Programmname

    while (cin.get(c))    // lesen von Std-Eingabe (Tastatur)
      cout.put(c);        // schreiben nach Std-Ausgabe (Bildschirm)
  }

  if (argc==2) {              // 2 Argumente,
    ifstream in(argv[1]);    // lesen aus Datei (Name = argv[1])

    while (in.get(c)) 
      cout.put(c);           // schreiben nach Std-Ausgabe (Bildschirm)
     in.close();
  }

  if (argc >= 3) {           // mehr als 2 Argumente
    ofstream out(argv[argc-1]); // letztes Argument: name einer Ausgabedatei

    for (int i = 1; i < argc - 1; i++) { // 1. bis vorletztes Arg: Dateien,
      ifstream in(argv[i]);  // aus denen gelesen werden soll,
      while (in.get(c))      // Inhalte aller dieser Dateien
	out.put(c);          // werden nacheinander in Ausgabedatei geschrieben
      in.close();
    }
    out.close();
  }
  return 0;
}
